<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>AlexaClientSDK: alexaClientSDK::acl::HTTP2Stream Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.9.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html">acl</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html">HTTP2Stream</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::acl::HTTP2Stream Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_h_t_t_p2_stream_8h_source.html">HTTP2Stream.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a2d4c6ff352ecbb6273442d6e4f3809eb"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a2d4c6ff352ecbb6273442d6e4f3809eb">HTTP2Stream</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_message_consumer_interface.html">MessageConsumerInterface</a> &gt; messageConsumer, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_manager.html">avsCommon::avs::attachment::AttachmentManager</a> &gt; attachmentManager)</td></tr>
<tr class="separator:a2d4c6ff352ecbb6273442d6e4f3809eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4a1bf5b8f907d6e2a4b11b99d830254e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a4a1bf5b8f907d6e2a4b11b99d830254e">initPost</a> (const std::string &amp;url, const std::string &amp;authToken, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html">avsCommon::avs::MessageRequest</a> &gt; request)</td></tr>
<tr class="separator:a4a1bf5b8f907d6e2a4b11b99d830254e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a108684f06ee34f166129c72535193f85"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a108684f06ee34f166129c72535193f85">initGet</a> (const std::string &amp;url, const std::string &amp;authToken)</td></tr>
<tr class="separator:a108684f06ee34f166129c72535193f85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9270d32109ca97df9162a0323bbac47e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a9270d32109ca97df9162a0323bbac47e">reset</a> ()</td></tr>
<tr class="separator:a9270d32109ca97df9162a0323bbac47e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a68b001de86272ba98e4ec75ddb2e10a6"><td class="memItemLeft" align="right" valign="top">CURL *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a68b001de86272ba98e4ec75ddb2e10a6">getCurlHandle</a> ()</td></tr>
<tr class="separator:a68b001de86272ba98e4ec75ddb2e10a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:accb434fbe95e6aabc98900c31c7441e6"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#accb434fbe95e6aabc98900c31c7441e6">getResponseCode</a> ()</td></tr>
<tr class="separator:accb434fbe95e6aabc98900c31c7441e6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd4f30aebf40913d4791a54bd4fb7704"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#afd4f30aebf40913d4791a54bd4fb7704">notifyRequestObserver</a> ()</td></tr>
<tr class="separator:afd4f30aebf40913d4791a54bd4fb7704"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3c6c0bedbbca9adcc07df3d098a80621"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a3c6c0bedbbca9adcc07df3d098a80621">notifyRequestObserver</a> (<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a> status)</td></tr>
<tr class="separator:a3c6c0bedbbca9adcc07df3d098a80621"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae082da53c9879e5b5059287efaba6b3f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#ae082da53c9879e5b5059287efaba6b3f">setStreamTimeout</a> (const long timeoutSeconds)</td></tr>
<tr class="separator:ae082da53c9879e5b5059287efaba6b3f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2fcf5ee4e262fb8d50f02d3348816a51"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a2fcf5ee4e262fb8d50f02d3348816a51">setConnectionTimeout</a> (const std::chrono::seconds timeoutSeconds)</td></tr>
<tr class="separator:a2fcf5ee4e262fb8d50f02d3348816a51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a591bc204231365aea785afcdccbe206d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a591bc204231365aea785afcdccbe206d">unPause</a> ()</td></tr>
<tr class="separator:a591bc204231365aea785afcdccbe206d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0878230ff33bc38f8d729599e2bc6094"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a0878230ff33bc38f8d729599e2bc6094">isPaused</a> () const </td></tr>
<tr class="separator:a0878230ff33bc38f8d729599e2bc6094"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a32fd59c375c62f78cc628241c27aac34"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a32fd59c375c62f78cc628241c27aac34">setLogicalStreamId</a> (int logicalStreamId)</td></tr>
<tr class="separator:a32fd59c375c62f78cc628241c27aac34"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acb0467ed23c069515429bd4f69c16c5c"><td class="memItemLeft" align="right" valign="top">unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#acb0467ed23c069515429bd4f69c16c5c">getLogicalStreamId</a> () const </td></tr>
<tr class="separator:acb0467ed23c069515429bd4f69c16c5c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a05b2efb8fb85c610fd4e959f15bc6b0c"><td class="memTemplParams" colspan="2">template&lt;class TickType , class TickPeriod  = std::ratio&lt;1&gt;&gt; </td></tr>
<tr class="memitem:a05b2efb8fb85c610fd4e959f15bc6b0c"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a05b2efb8fb85c610fd4e959f15bc6b0c">setProgressTimeout</a> (std::chrono::duration&lt; TickType, TickPeriod &gt; duration)</td></tr>
<tr class="separator:a05b2efb8fb85c610fd4e959f15bc6b0c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2e66917af1c33a7fa33c8f503d3b03f6"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a2e66917af1c33a7fa33c8f503d3b03f6">hasProgressTimedOut</a> () const </td></tr>
<tr class="separator:a2e66917af1c33a7fa33c8f503d3b03f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef44fdfdfa74bf2081f4ad6c0f83940e"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#aef44fdfdfa74bf2081f4ad6c0f83940e">getFailureBody</a> () const </td></tr>
<tr class="separator:aef44fdfdfa74bf2081f4ad6c0f83940e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a769b79e91fbe51b5924acfe98b2f134c"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_string_formatter.html">avsCommon::utils::logger::LogStringFormatter</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a769b79e91fbe51b5924acfe98b2f134c">getLogFormatter</a> () const </td></tr>
<tr class="separator:a769b79e91fbe51b5924acfe98b2f134c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a273bed83d02a494fe2cb6c81cd2f48de"><td class="memItemLeft" align="right" valign="top">static size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a273bed83d02a494fe2cb6c81cd2f48de">writeCallback</a> (char *data, size_t size, size_t nmemb, void *userData)</td></tr>
<tr class="separator:a273bed83d02a494fe2cb6c81cd2f48de"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a6a9a6eae290e4ea0f92bd792ddc73a"><td class="memItemLeft" align="right" valign="top">static size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a0a6a9a6eae290e4ea0f92bd792ddc73a">headerCallback</a> (char *data, size_t size, size_t nmemb, void *userData)</td></tr>
<tr class="separator:a0a6a9a6eae290e4ea0f92bd792ddc73a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83990d017b861cd3d332ad7297c40f0f"><td class="memItemLeft" align="right" valign="top">static size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_stream.html#a83990d017b861cd3d332ad7297c40f0f">readCallback</a> (char *data, size_t size, size_t nmemb, void *userData)</td></tr>
<tr class="separator:a83990d017b861cd3d332ad7297c40f0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Class that represents an HTTP/2 stream. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a2d4c6ff352ecbb6273442d6e4f3809eb"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::acl::HTTP2Stream::HTTP2Stream </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_message_consumer_interface.html">MessageConsumerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>messageConsumer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_manager.html">avsCommon::avs::attachment::AttachmentManager</a> &gt;&#160;</td>
          <td class="paramname"><em>attachmentManager</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Constructor.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">messageConsumer</td><td>The <a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_message_consumer_interface.html">MessageConsumerInterface</a> which should receive messages from AVS. </td></tr>
    <tr><td class="paramname">attachmentManager</td><td>The attachment manager. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a68b001de86272ba98e4ec75ddb2e10a6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CURL * alexaClientSDK::acl::HTTP2Stream::getCurlHandle </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the CURL easy handle associated with this stream</p>
<dl class="section return"><dt>Returns</dt><dd>The associated curl easy handle for the stream </dd></dl>

</div>
</div>
<a class="anchor" id="aef44fdfdfa74bf2081f4ad6c0f83940e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::acl::HTTP2Stream::getFailureBody </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Return the body (if any) returned for a failed request.</p>
<dl class="section return"><dt>Returns</dt><dd>The body (if any) returned for a failed request. </dd></dl>

</div>
</div>
<a class="anchor" id="a769b79e91fbe51b5924acfe98b2f134c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_string_formatter.html">avsCommon::utils::logger::LogStringFormatter</a> &amp; alexaClientSDK::acl::HTTP2Stream::getLogFormatter </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Return a reference to the LogStringFormatter owned by this object. This is to allow a callback that uses this object to get access to a known good LogStringFormatter.</p>
<dl class="section return"><dt>Returns</dt><dd>A reference to a LogStringFormatter. </dd></dl>

</div>
</div>
<a class="anchor" id="acb0467ed23c069515429bd4f69c16c5c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int alexaClientSDK::acl::HTTP2Stream::getLogicalStreamId </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get the logical ID of this stream.</p>
<dl class="section return"><dt>Returns</dt><dd>The logical ID of this stream. </dd></dl>

</div>
</div>
<a class="anchor" id="accb434fbe95e6aabc98900c31c7441e6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">long alexaClientSDK::acl::HTTP2Stream::getResponseCode </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns the HTTP response code to the action this stream performs.</p>
<dl class="section return"><dt>Returns</dt><dd>The HTTP response code if one has been received, 0 if not, and &lt; 0 if there is an error </dd></dl>

</div>
</div>
<a class="anchor" id="a2e66917af1c33a7fa33c8f503d3b03f6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::acl::HTTP2Stream::hasProgressTimedOut </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Return whether or not the progress timeout has been reached.</p>
<dl class="section return"><dt>Returns</dt><dd>Whether or not the progress timeout has been reached. </dd></dl>

</div>
</div>
<a class="anchor" id="a0a6a9a6eae290e4ea0f92bd792ddc73a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">size_t alexaClientSDK::acl::HTTP2Stream::headerCallback </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>nmemb</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>userData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Callback that gets executed when HTTP headers are received from the server See <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_curl_easy_handle_wrapper.html#ae2809e455ecb95686d32239554f85156">CurlEasyHandleWrapper::CurlCallback</a> for details </p>

</div>
</div>
<a class="anchor" id="a108684f06ee34f166129c72535193f85"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::acl::HTTP2Stream::initGet </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>url</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>authToken</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Initializes streams that are supposed to perform an HTTP GET Note the authToken that is passed in will get used at a later time. Ensure that the token will not expire soon.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">url</td><td>The request URL </td></tr>
    <tr><td class="paramname">authToken</td><td>The LWA token </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the setup was successful or not </dd></dl>

</div>
</div>
<a class="anchor" id="a4a1bf5b8f907d6e2a4b11b99d830254e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::acl::HTTP2Stream::initPost </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>url</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>authToken</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html">avsCommon::avs::MessageRequest</a> &gt;&#160;</td>
          <td class="paramname"><em>request</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Initializes streams that are supposed to POST the given request. Note the authToken that is passed in will get used at a later time. Ensure that the token will not expire soon.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">url</td><td>The request URL </td></tr>
    <tr><td class="paramname">authToken</td><td>The LWA token </td></tr>
    <tr><td class="paramname">request</td><td>The MessageRequest to post </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if setup was successful </dd></dl>

</div>
</div>
<a class="anchor" id="a0878230ff33bc38f8d729599e2bc6094"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::acl::HTTP2Stream::isPaused </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Return whether this stream has pending transfers. </p>

</div>
</div>
<a class="anchor" id="afd4f30aebf40913d4791a54bd4fb7704"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::acl::HTTP2Stream::notifyRequestObserver </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Notify the current request observer that the transfer is complete with the appropriate SendCompleteStatus code. </p>

</div>
</div>
<a class="anchor" id="a3c6c0bedbbca9adcc07df3d098a80621"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::acl::HTTP2Stream::notifyRequestObserver </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a>&#160;</td>
          <td class="paramname"><em>status</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Notify the current request observer that the transfer is complete with the specified status code.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">status</td><td>The completion status. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a83990d017b861cd3d332ad7297c40f0f"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">size_t alexaClientSDK::acl::HTTP2Stream::readCallback </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>nmemb</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>userData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Callback that gets executed when the server requires data. See CurlEasyHandleWrapper::curlCallback for details.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">data</td><td>A pointer to the data buffer to either read or write to. </td></tr>
    <tr><td class="paramname">size</td><td>The size of a "block" of data (ala fwrite). </td></tr>
    <tr><td class="paramname">nmemb</td><td>The number of "blocks" to read or write. </td></tr>
    <tr><td class="paramname">userData</td><td>Some user data passed in with CURLOPT_READDATA. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The amount of bytes read. </dd></dl>

</div>
</div>
<a class="anchor" id="a9270d32109ca97df9162a0323bbac47e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::acl::HTTP2Stream::reset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets up a stream for re-use</p>
<dl class="section return"><dt>Returns</dt><dd>Whether the reset was successful or not </dd></dl>

</div>
</div>
<a class="anchor" id="a2fcf5ee4e262fb8d50f02d3348816a51"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::acl::HTTP2Stream::setConnectionTimeout </td>
          <td>(</td>
          <td class="paramtype">const std::chrono::seconds&#160;</td>
          <td class="paramname"><em>timeoutSeconds</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets how long, in seconds, the stream should take to establish a connection. If not explicitly set there is no timeout.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">timeoutSeconds</td><td>The connection timeout, in seconds. Set to <code>0</code> to disable an existing timeout. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether setting the timeout was successful. </dd></dl>

</div>
</div>
<a class="anchor" id="a32fd59c375c62f78cc628241c27aac34"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::acl::HTTP2Stream::setLogicalStreamId </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>logicalStreamId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Set the logical stream ID for this stream.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">logicalStreamId</td><td>The new value for this streams logical stream ID. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a05b2efb8fb85c610fd4e959f15bc6b0c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TickType , class TickPeriod &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::acl::HTTP2Stream::setProgressTimeout </td>
          <td>(</td>
          <td class="paramtype">std::chrono::duration&lt; TickType, TickPeriod &gt;&#160;</td>
          <td class="paramname"><em>duration</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Set the timeout for this stream to make progress sending or receiving.</p>
<dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">TickType</td><td>Type to represent tick count. </td></tr>
    <tr><td class="paramname">TickPeriod</td><td><code>std::ratio</code> specifying ticks per second. </td></tr>
  </table>
  </dd>
</dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">duration</td><td>Max time the stream may make no progress before <code>getHasProgressTimedOut()</code> returns true. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae082da53c9879e5b5059287efaba6b3f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::acl::HTTP2Stream::setStreamTimeout </td>
          <td>(</td>
          <td class="paramtype">const long&#160;</td>
          <td class="paramname"><em>timeoutSeconds</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the max amount of time in seconds the stream can take. If not set explicitly there is no timeout.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">timeoutSeconds</td><td>The timeout in seconds, set to <code>0</code> to disable an existing timeout. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the addition was successful </dd></dl>

</div>
</div>
<a class="anchor" id="a591bc204231365aea785afcdccbe206d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::acl::HTTP2Stream::unPause </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Un-pend all transfers for this stream </p>

</div>
</div>
<a class="anchor" id="a273bed83d02a494fe2cb6c81cd2f48de"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">size_t alexaClientSDK::acl::HTTP2Stream::writeCallback </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>nmemb</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>userData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Callback that gets executed when data is received from the server See <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_curl_easy_handle_wrapper.html#ae2809e455ecb95686d32239554f85156">CurlEasyHandleWrapper::CurlCallback</a> for details </p>
<p>If we get an HTTP 200 response code then we're getting a MIME multipart payload. For all other response codes we're getting a JSON string without multipart headers.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/ACL/include/ACL/Transport/<a class="el" href="_h_t_t_p2_stream_8h_source.html">HTTP2Stream.h</a></li>
<li>/workplace/avs-device-sdk/ACL/src/Transport/<a class="el" href="_h_t_t_p2_stream_8cpp.html">HTTP2Stream.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.9.0 - Copyright 2016-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
